*
* $Id: gpce.F,v 3.2 2003/12/17 11:32:48 pamela Exp $
*
* $Log: gpce.F,v $
* Revision 3.2  2003/12/17 11:32:48  pamela
* CALO SIMULATION COMPLETED: geometry and special tracking parameters updated and simulation checked by a comparison with the Trieste's standalone Monte Carlo simulation
*
* Revision 3.1.1.1  2002/07/11 16:02:14  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  3.00/00 04/12/2000  14.13.29  by  Emiliano Mocchiutti
*CMZ :  2.03/00 30/10/2000  10.46.27  by  Francesco Cafagna
*CMZ :  2.02/00 09/10/2000  15.45.18  by  Francesco Cafagna
*-- Author :
      SUBROUTINE GPCE
************************************************************************
*                                                                      *
* To define special tracking parameters for Kaolinite                  *
*                                                                      *
* Called by: GPDAT                                                     *
* Author: Emiliano Mocchiutti, 09/10/00 15.28.17                       *
*                                                                      *
************************************************************************
#include "gpce.inc"
*
      CUTGAMCE = 0.00001
      CUTELECE = 0.00001
      CUTNEUCE = 0.001
      CUTHADCE = 0.001
c ml:
      BCUTECE=0.00001
      DCUTECE=0.00001
      CUTMUOCE=0.01
      BCUTMCE=0.00001
      DCUTMCE=0.00001
      PPCUTMCE=0.01
c end ml.
      PAIRCE = 1
      COMPCE = 1
      PHOTCE = 1
      PFISCE = 0
      DRAYCE = 1
      ANNICE = 1
      BREMCE = 1
      HADRCE = 1
      MUNUCE = 1
      DCAYCE = 1
      LOSSCE = 1
      MULSCE = 2
      RETURN
      END

      SUBROUTINE GPNDV
************************************************************************
*                                                                      *
* Volumes definition for the neutron detector                          *
* Called by: GPGEOM                                                    *
* Author: Francesco Cafagna, 05-sep-05                                 *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpkey.inc"
*
      INTEGER IROT,IVOLU,N,NMED
      REAL X,Y,Z
*
*  Define the NDBX     volume
*
      NMED= MAL
      CALL GSVOLU('NDBX','BOX ',NMED,NDBX, 3,IVOLU)
*
*  Define the NDBI     volume
*
      NMED= MN2
      CALL GSVOLU('NDBI','BOX ',NMED,NDBI, 3,IVOLU)
*
*  Define the NDTU     volume
*
      NMED= MIRON
      NMED= MSCIN
      CALL GSVOLU('NDTU','TUBE',NMED,NDTU, 3,IVOLU)
*
*  Define the NDTI     volume
*
      NMED= MHEND
      NMED= MSCIN
      CALL GSVOLU('NDTI','TUBE',NMED,NDTI, 3,IVOLU)
*
*  Define the NDPB     volume
*
      NMED= MC2H4
      NMED= MN2
      CALL GSVOLU('NDPB','BOX ',NMED,NDPB, 3,IVOLU)
*
*  Define the NDCD     volume
*
      NMED= MN2
      CALL GSVOLU('NDCD','BOX ',NMED,NDCD, 3,IVOLU)
*
* Positioning volumes NDTI inside NDTU. 
*
      N = 1
      X = 0.
      Y = 0.
      Z = 0.
      CALL GSPOS('NDTI',N,'NDTU',X,Y,Z,0,'ONLY')
*
* Positioning volume NDTU inside the mother NDPB 
*
      N = 0
      Y = 0.
C # 
C # Start to put tube on top of a cmd and 3 pholyetilene planes
C # 
      DO I=1,2
C # 
C # Place a tube layer at a 4 mm distance each
C #
         X = -NDBI(2) + 0.2 + 1.1
         Z = -NDBI(3) + 2.*NDCD(3) + 3.*(2.*NDPB(3)) + NDTU(2) 
     +        + (I-1)*4*NDPB(3)
         DO II=1,18
            N= N + 1
            CALL GSPOS('NDTU',N,'NDBI',X,Y,Z,2,'MANY')
            X = X + 2.2 
         ENDDO
      ENDDO
*
* Positioning volume NDPB inside the mother NDPB 
*
      N = 0
      X = 0.
      Y = 0.
C # 
C # Stack 3 planes then leave the tube gap between the last two
C #
      DO I=1,3
         N= N + 1
         Z = -NDBI(3) + 2.*NDCD(3) + (I-1)*2.*NDPB(3) + NDPB(3)  
         CALL GSPOS('NDPB',N,'NDBI',X,Y,Z,0,'MANY')
      ENDDO
      DO I=1,2
         Z = -NDBI(3) + 2.*NDCD(3) + 4.*2.*NDPB(3) + NDPB(3) 
     +        + (I-1)*4.*NDPB(3)
         N= N + 1
         CALL GSPOS('NDPB',N,'NDBI',X,Y,Z,0,'MANY')
      ENDDO
C # 
C # Positioning the NDCD
C #
      N=1
      X = 0 
      Y = 0
      Z = -NDBI(3) + NDCD(3)
      CALL GSPOS('NDCD',N,'NDBI',X,Y,Z,0,'MANY')
      N = N +1
      Z = -NDBI(3) + 2.*NDCD(3) + 7.*2.*NDPB(3)+ NDCD(3)
      CALL GSPOS('NDCD',N,'NDBI',X,Y,Z,0,'MANY')
C # 
C # Now put the internal volume inside the aluminum box 
C # *
      N = 1
      X = 0.
      Y = 0.
      Z = 0.
      CALL GSPOS('NDBI',N,'NDBX',X,Y,Z,0,'MANY')

      RETURN
      END

      SUBROUTINE GPDND
************************************************************************
*                                                                      *
* To perform ND digitization                                          *
*                                                                      *
* Called by: GUDIGI                                                    *
* Author: Francesco Cafagna, 23/02/06 12.50.38                         *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gpphit.inc"
      PARAMETER (NH=NHND,NHM=NHMND,NVOL=2)
#include "gprhit.inc"
#include "gpnd.inc"
#include "gpsed.inc"
*
      INTEGER IS,ID,NV,NVM,NNHM
      CHARACTER*4 CSET
      DATA CSET/'ND  '/
*
* Vector zeroed
*
      CALL VZERO(ITUBEND,NHM)
      CALL VZERO(IPARND,NHM)
      CALL VZERO(XINND,NHM)
      CALL VZERO(YINND,NHM)
      CALL VZERO(ZINND,NHM)
      CALL VZERO(XOUTND,NHM)
      CALL VZERO(YOUTND,NHM)
      CALL VZERO(ZOUTND,NHM)
      CALL VZERO(ERELND,NHM)
      CALL VZERO(TIMEND,NHM)
      CALL VZERO(PATHND,NHM)
      CALL VZERO(P0ND,NHM)
*
      CALL VZERO(NUMD  ,NVOL)
*
* Start with nd top
*
      NV = NVOL
      NVM= NVMAX
      IT = -1
      NTHND = 0
      INDEX = 0
      IS= ISND
      ID= IDNDTI
*
* Check on the volume level
*
      IF (NV.GT.NVM) THEN
         WRITE(CHMAIL,10000) CSET,CNSED(IS,ID),NVOL,NVMAX, IDRUN,
     +        IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
      CALL VZERO(VHITS,NH*NHM)
      CALL VZERO(ITRA ,NHM)
      CALL VZERO(NUMBV,NVOL*NHM)
      NHITS = -1
      CALL GPRHIT(CSET,CNSED(IS,ID),IS,ID,NVOL,NH,NHM,1,
     +     IT,NUMD,ITRA,NUMBV,VHITS,NHITS)
*     
*     If there was a problem in GPRHIT then exit
*     
      IF(NHITS.LT.0) THEN
         WRITE(CHMAIL,10200) CSET,CNSED(IS,ID),NHITS,NHM,
     +        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
*     
*     Fill the CWN common
*     
      NTHND = NHITS 
      DO I=1,NHITS
         ITUBEND(I) = NUMBV(1,I)
         XINND(I) = VHITS(1,I)
         YINND(I) = VHITS(2,I)
         ZINND(I) = VHITS(3,I)
         XOUTND(I) = VHITS(4,I)
         YOUTND(I) = VHITS(5,I)
         ZOUTND(I) = VHITS(6,I)
         ERELND(I) = VHITS(7,I)
         TIMEND(I) = VHITS(8,I)
         PATHND(I) = VHITS(9,I)
         IPARND(I) = VHITS(10,I)
         P0ND (I) = VHITS(11,I)
*     
      ENDDO
      
*
10000 FORMAT(' GPDND: VOLUME level too big: SET=',A4,', DET=',A4,
     +     ',NVOL=',I3,', NVMAX=',I3,', RUN=',I5,', EVT=',I8)
10100 FORMAT(' GPDND: MAX number of hits retrived: SET=',A4,
     +     ', DET=',A4,',NHREAD=',I5,', NHMAX=',I5,
     +     ', RUN=',I5,', EVT=',I8)
10200 FORMAT(' GPDND: Error in GPRHIT: SET=',A4,
     +     ', DET=',A4,',NHITS=',I5,', NHMAX=',I5,
     +     ', RUN=',I5,', EVT=',I8)
 10   RETURN
      END

      SUBROUTINE GPGIGP
*************************************************************************
*                                                                      *
* To define new neutron for gigantic resonance.                        *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/05                                  *
*                                                                      *
************************************************************************
#include "gpgig.inc"
*
      CALL GFPART(13,GIGNAM,IPTYP,AMGIG,ZGIG,TLGIG,UPGIG,NBGIG)
      GIGNAM='GIGneutron$        '
      IPGIG =51
      UPGIG(1)= 1.
      UPGIG(2)= 2.
      UPGIG(3)= 3.
      NBGIG = 3
      CALL GSPART(IPGIG,GIGNAM,IPTYP,AMGIG,ZGIG,TLGIG,UPGIG,NBGIG)
      RETURN
      END

*
* $Id: gpustep.F,v 3.1.1.1 2002/07/11 16:02:00 cafagna Exp $
*
* $Log: gpustep.F,v $
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  3.00/00 11/05/2001  13.44.09  by  Marialuigia Ambriola
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 30/04/96  18.28.33  by  Francesco Cafagna
*CMZ :  1.00/03 29/04/96  16.56.08  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   29/04/96
      SUBROUTINE GPGIG
************************************************************************
*                                                                      *
* User action in GUSTEP                                                *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IFLAG = 1, just entered GUSTEP                                      *
*  IFLAG = 2, leaving GUSTEP                                           *
*                                                                      *
* Called by: GUSTEP                                                    *
* Author: Francesco Cafagna, 29/04/96 16.56.08                         *
*                                                                      *
************************************************************************
#include "gpques.inc"
#include "gctmed.inc"
#include "gckine.inc"
#include "gcking.inc"
#include "gcflag.inc"
#include "gctrak.inc"
#include "gcvolu.inc"
#include "gcsets.inc"
#include "gpkey.inc"
#include "gpsed.inc"
      
*
      LOGICAL W,GPLOOK
      INTEGER IFLAG
      INTEGER IFL,IN,MECNAM(MAXMEC)
      IF(IFLAG.EQ.1) GO TO 999
      IN = INWVOL
      IF(IN.NE.0) GO TO 999
C #       open(20,file='GIG.dat',access='append')
C #       open(21,file='All.dat',access='append')
*
* Is it a gamma ?
*
      IF ((IPART.NE.1).AND.(IPART.NE.13)) GO TO 999
      IF (IPART.EQ.13) write(*,*)'particle=',IPART
*
* Store the mechanisms active for the current step
*
      IF(NMEC.EQ.0)THEN
         MECNAM(1)=NAMEC(29)
      ELSE
         DO I=1,NMEC
            MEC=LMEC(I)
            IF(MEC.LE.MAXMEC) THEN
               MECNAM(I)=NAMEC(MEC)
            ELSEIF(MEC-100.LE.MAXME1.AND.MEC-100.GT.0) THEN
               MECNAM(I)=NAMEC1(MEC-100)
            ENDIF
         ENDDO
      ENDIF
*
      W=GPLOOK('CAAB',NAMES,NLEVEL) 
      IF(W) THEN
c      CALL GPCXYZ
      IF ((GETOT.GT.0.009097).AND.(GETOT.LT.0.028608).AND.(IPART.EQ.1))
     + then
c      PRINT *, ' GPUSTEP : WE FOUND A GAMMA INTO THE W ! Energy:'
c     +        ,GETOT
C #       write(20,'(1x,f7.3,1x,f6.3,1x,i4,1x,a10,1x,i4,5(1x,e13.6),1x,i4)')
C #      + GETOT*1000., STEP, ISTAK, KCASE, NGKINE,
C #      + VECT(4)*VECT(7)*1000., VECT(5)*VECT(7)*1000., 
C #      + VECT(6)*VECT(7)*1000., VECT(7)*1000., VECT(3), NUMBER(NLEVEL)
      ENDIF
C #       IF (IPART.EQ.13) then
C #       write(21,'(1x,f7.3,1x,f6.3,1x,i4,1x,a10,1x,i4,5(1x,e13.6),1x,i4)')
C #      + GETOT*1000., STEP, ISTAK, KCASE, NGKINE,
C #      + VECT(4)*VECT(7)*1000., VECT(5)*VECT(7)*1000., 
C #      + VECT(6)*VECT(7)*1000., VECT(7)*1000., VECT(3), NUMBER(NLEVEL)      
C #       ENDIF
      ENDIF
999   CONTINUE
C #       close(20)
C #       close(21)
     
      RETURN
      END
